diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
index e6b2c4d44..279fb98c3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
@@ -11,9 +11,7 @@ import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.FullSupport;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
-import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
@@ -29,7 +27,7 @@ import org.joml.primitives.AABBdc;
 
 import static net.minecraft.core.block.piston.PistonCommon.*;
 
-public class BlockLogicPistonHead extends BlockLogic {
+public class BlockLogicPistonHead extends BlockLogic implements BlockLogic.MatcherDataEquivalency.Masked {
 
     // "Good lord. This really is our most NSFW update" -- Jonk
     // "Daaayyymmnn boy! He thick boy! That's a thick ass boy, DAYMN!" -- Melon
@@ -43,8 +41,8 @@ public class BlockLogicPistonHead extends BlockLogic {
     }
 
     @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return data & ~DIRECTION.mask;
+    public int getMatcherDataEquivalencyMask() {
+        return ~DIRECTION.mask;
     }
 
     @Override
@@ -138,7 +136,6 @@ public class BlockLogicPistonHead extends BlockLogic {
         if (!(world.getBlockType(bpos).getLogic() instanceof BlockLogicPistonBase)) return;
         int bdat = fixLegacyBaseData(world, bpos);
         if (PAIR_COMPARISON.get(data ^ bdat) != 0) return;
-        final var b = world.getBlockType(bpos);
         world.setBlockTypeNotify(bpos, Blocks.AIR);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
index fc2e937fc..a898d12c1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
@@ -139,7 +139,11 @@ public class BlockLogicPistonMoving extends BlockLogic {
     }
 
     @Override
-    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
+    public boolean isEquivalent(
+        @NotNull WorldSource world,
+        @NotNull TilePosc thisPos, @NotNull TilePosc thatPos,
+        @NotNull Block<?> thatBlock
+    ) {
         return false;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/MovingLine.java b/game/core/src/main/java/net/minecraft/core/block/piston/MovingLine.java
index d97eda610..f35b038e1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/MovingLine.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/MovingLine.java
@@ -174,6 +174,7 @@ public final class MovingLine {
         if (world.isBlockNormalCube(tilePos)) direct_sig: {
             if (block == Blocks.BLOCK_REDSTONE) break direct_sig;
             if (block == Blocks.PUMPKIN_REDSTONE) break direct_sig;
+            if (block == Blocks.MATCHER) break direct_sig;
             if (block == Blocks.MATCHER_ACTIVE) break direct_sig;
             if (world.hasDirectSignal(queryPos.set(tilePos).add(d1), d1.side())) return true;
             if (world.hasDirectSignal(queryPos.set(tilePos).add(d2), d2.side())) return true;
diff --git a/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java b/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java
index 044e534f0..5470cc82f 100644
--- a/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java
+++ b/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java
@@ -19,7 +19,7 @@ public class BlockState {
 	private final @NotNull Block<?> block;
 	private final int metadata;
 
-	public BlockState(Block<?> block, int metadata) {
+	public BlockState(@NotNull Block<?> block, int metadata) {
 		this.block = block;
 		this.metadata = metadata;
 	}
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/Node.java b/game/core/src/main/java/net/minecraft/core/current/wire/Node.java
index efabe2edc..c16b1d4ec 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/Node.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/Node.java
@@ -6,6 +6,7 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Arrays;
 
@@ -61,7 +62,7 @@ public class Node {
         return this.pos.hashCode();
     }
 
-    Node set(TilePosc pos, BlockState state, boolean clearNeighbors) {
+    Node set(TilePosc pos, @NotNull BlockState state, boolean clearNeighbors) {
         if (state.is(Blocks.WIRE_REDSTONE)) {
             throw new IllegalStateException("Cannot update a regular Node to a WireNode!");
         }
@@ -97,6 +98,13 @@ public class Node {
         return false;
     }
 
+    public boolean isWireAndIs(WireNode.Medium medium) {
+        if (this.isWire()) {
+            return this.asWire().medium == medium;
+        }
+        return false;
+    }
+
     public boolean isConductor() {
         return (this.flags & CONDUCTOR) != 0;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WireConnection.java b/game/core/src/main/java/net/minecraft/core/current/wire/WireConnection.java
index 86c6fa7bd..bb4fcfa04 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/WireConnection.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WireConnection.java
@@ -4,27 +4,35 @@ package net.minecraft.core.current.wire;
  * This class represents a connection between some WireNode (the 'owner') and a
  * neighboring WireNode. Two wires are considered to be connected if power can
  * flow from one wire to the other (and/or vice versa).
- * 
+ *
+ * <p>A node here may be any {@link WireNode.Medium}.
+ * Power crosses every connection with a uniform step of {@link WireHandler}'s
+ * POWER_STEP.
+ *
  * @author Space Walker
+ * @author MelonMojito
  */
 public class WireConnection {
 
 	/** The connected wire. */
 	final WireNode wire;
-	/** Cardinal direction to the connected wire. */
+	/** Cardinal (or vertical) direction to the connected wire. */
 	final int iDir;
 	/** True if the owner of the connection can provide power to the connected wire. */
 	final boolean offer;
 	/** True if the connected wire can provide power to the owner of the connection. */
 	final boolean accept;
+	/** True if this connection should contribute to the owner's horizontal flow direction.*/
+	final boolean flow;
 
 	/** The next connection in the sequence. */
 	WireConnection next;
 
-	WireConnection(WireNode wire, int iDir, boolean offer, boolean accept) {
+	WireConnection(WireNode wire, int iDir, boolean offer, boolean accept, boolean flow) {
 		this.wire = wire;
 		this.iDir = iDir;
 		this.offer = offer;
 		this.accept = accept;
+		this.flow = flow;
 	}
 }
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WireConnectionManager.java b/game/core/src/main/java/net/minecraft/core/current/wire/WireConnectionManager.java
index 2de7e2267..12ba77d71 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/WireConnectionManager.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WireConnectionManager.java
@@ -5,16 +5,20 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.current.wire.WireHandler.Directions;
 import net.minecraft.core.current.wire.WireHandler.NodeProvider;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Arrays;
 import java.util.function.Consumer;
 
+import static net.minecraft.core.current.wire.WireNode.Medium.CONDUIT;
+import static net.minecraft.core.current.wire.WireNode.Medium.DUST;
+
 public class WireConnectionManager {
 
 	/** The owner of these connections. */
 	final WireNode owner;
 
-	/** The first connection for each cardinal direction. */
+	/** The first connection for each cardinal direction. (Flow only) */
 	private final WireConnection[] heads;
 
 	private WireConnection head;
@@ -23,10 +27,7 @@ public class WireConnectionManager {
 	/** The total number of connections. */
 	int total;
 
-	/**
-	 * A 4 bit number that encodes which in direction(s) the owner has connections
-	 * to other wires.
-	 */
+	/** A 4 bit number that encodes direction(s) the owner has flow connections with other dust wires. */
 	private int flowTotal;
 	/** The direction of flow based connections to other wires. */
 	int iFlowDir;
@@ -47,6 +48,19 @@ public class WireConnectionManager {
 			clear();
 		}
 
+		if (owner.is(CONDUIT)) {
+			setConduit(nodes);
+		} else {
+			setDust(nodes);
+			addConduitLinks(nodes);
+		}
+
+		if (total > 0) {
+			iFlowDir = WireHandler.FLOW_IN_TO_FLOW_OUT[flowTotal];
+		}
+	}
+
+	private void setDust(@NotNull NodeProvider nodes) {
 		//tried my best to keep original AltCurrent naming schemes when changing code here
 
 		Node ownerDown = nodes.getNeighbor(owner, Directions.DOWN);
@@ -60,8 +74,8 @@ public class WireConnectionManager {
 		for (int iDir = 0; iDir < Directions.HORIZONTAL.length; iDir++) {
 			Node neighbor = nodes.getNeighbor(owner, iDir);
 
-			if (neighbor.isWire()) {
-				add(neighbor.asWire(), iDir, true, true);
+			if (neighbor.isWireAndIs(DUST)) {
+				add(neighbor.asWire(), iDir, true, true, true);
 
 				continue;
 			}
@@ -77,10 +91,10 @@ public class WireConnectionManager {
 			if (!blockedDown) {
 				Node node = nodes.getNeighbor(neighbor, Directions.DOWN);
 
-				if (node.isWire()) {
+				if (node.isWireAndIs(DUST)) {
 					boolean offerDown = belowIsConductor ||
 							(ownerDown.state.is(Blocks.CONDUIT) && !isConduitOpenTowards(ownerDown, iDir));
-					add(node.asWire(), iDir, offerDown, true);
+					add(node.asWire(), iDir, offerDown, true, true);
 				}
 			}
 
@@ -92,16 +106,46 @@ public class WireConnectionManager {
 			if (!blockedUp) {
 				Node node = nodes.getNeighbor(neighbor, Directions.UP);
 
-				if (node.isWire()) {
+				if (node.isWireAndIs(DUST)) {
 					boolean acceptUp = sideIsConductor ||
 							(neighbor.state.is(Blocks.CONDUIT) && !isConduitOpenTowards(neighbor, iOppDir));
-					add(node.asWire(), iDir, true, acceptUp);
+					add(node.asWire(), iDir, true, acceptUp, true);
 				}
 			}
 		}
+	}
 
-		if (total > 0) {
-			iFlowDir = WireHandler.FLOW_IN_TO_FLOW_OUT[flowTotal];
+	private void addConduitLinks(NodeProvider nodes) {
+		for (int iDir = 0; iDir < Directions.ALL.length; iDir++) {
+			Node neighbor = nodes.getNeighbor(owner, iDir);
+
+			if (neighbor.isWireAndIs(CONDUIT) && isConduitOpenTowards(neighbor, Directions.iOpposite(iDir))) {
+				add(neighbor.asWire(), iDir, true, true, false);
+			}
+		}
+	}
+
+	private void setConduit(NodeProvider nodes) {
+		for (int iDir = 0; iDir < Directions.ALL.length; iDir++) {
+			if (!isConduitOpenTowards(owner, iDir)) {
+				continue;
+			}
+
+			Node neighbor = nodes.getNeighbor(owner, iDir);
+
+			if (!neighbor.isWire()) {
+				continue;
+			}
+
+			WireNode wireNeighbor = neighbor.asWire();
+
+			if (wireNeighbor.is(CONDUIT)) {
+				if (isConduitOpenTowards(neighbor, Directions.iOpposite(iDir))) {
+					add(wireNeighbor, iDir, true, true, false);
+				}
+			} else {
+				add(wireNeighbor, iDir, true, true, false);
+			}
 		}
 	}
 
@@ -111,7 +155,7 @@ public class WireConnectionManager {
 	 * @param iDir The Alternate Current direction we are querying
 	 * @return true if the node is a conduit AND the port facing iDir is open
 	 */
-	private boolean isConduitOpenTowards(Node node, int iDir) {
+	private boolean isConduitOpenTowards(@NotNull Node node, int iDir) {
 		if (node.state.is(Blocks.CONDUIT)) {
 			Side face = Side.NONE;
             face = switch (iDir) {
@@ -140,8 +184,8 @@ public class WireConnectionManager {
 		iFlowDir = -1;
 	}
 
-	private void add(WireNode wire, int iDir, boolean offer, boolean accept) {
-		add(new WireConnection(wire, iDir, offer, accept));
+	private void add(WireNode wire, int iDir, boolean offer, boolean accept, boolean flow) {
+		add(new WireConnection(wire, iDir, offer, accept, flow));
 	}
 
 	private void add(WireConnection connection) {
@@ -155,7 +199,8 @@ public class WireConnectionManager {
 
 		total++;
 
-		if (heads[connection.iDir] == null) {
+		// Only horizontal dust-flow connections are tracked for flow ordering.
+		if (connection.flow && heads[connection.iDir] == null) {
 			heads[connection.iDir] = connection;
 			flowTotal |= (1 << connection.iDir);
 		}
@@ -173,11 +218,20 @@ public class WireConnectionManager {
 
 	/**
 	 * Iterate over all connections. Use this method if the iteration order is
-	 * important.
+	 * important. Horizontal dust-flow connections are visited first, in the order
+	 * determined by the flow direction, then any conduit/vertical connections.
 	 */
 	void forEach(Consumer<WireConnection> consumer, int iFlowDir) {
 		for (int iDir : WireHandler.CARDINAL_UPDATE_ORDERS[iFlowDir]) {
 			for (WireConnection c = heads[iDir]; c != null && c.iDir == iDir; c = c.next) {
+				if (c.flow) {
+					consumer.accept(c);
+				}
+			}
+		}
+
+		for (WireConnection c = head; c != null; c = c.next) {
+			if (!c.flow) {
 				consumer.accept(c);
 			}
 		}
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java b/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java
index 9565b40a6..b6e901fe4 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.current.wire;
 
 import net.minecraft.core.block.BlockLogicConduit;
+import net.minecraft.core.block.BlockLogicMatcher;
+import net.minecraft.core.block.BlockLogicVeryRotatable;
 import net.minecraft.core.block.BlockLogicWireRedstone;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
@@ -17,6 +19,8 @@ import java.util.Map;
 import java.util.Queue;
 import java.util.function.Consumer;
 
+import static net.minecraft.core.current.wire.WireNode.Medium.CONDUIT;
+
 /**
  * This class handles power changes for redstone wire. The algorithm was
  * designed with the following goals in mind:
@@ -339,7 +343,18 @@ public class WireHandler {
      * cache and update it.
      */
     private @NotNull Node getNextNode(@NotNull TilePosc pos, @NotNull BlockState state) {
-        return state.is(Blocks.WIRE_REDSTONE) ? new WireNode(this.world, pos, state) : getNextNode().set(pos, state, true);
+        return isPowerNodeState(state) ? new WireNode(this.world, pos, state) : getNextNode().set(pos, state, true);
+    }
+
+    /** closed and inert conduits carry nothing and are treated as ordinary blocks. */
+    private static boolean isPowerNodeState(@NotNull BlockState state) {
+        if (state.is(Blocks.WIRE_REDSTONE)) {
+            return true;
+        }
+        if (state.is(Blocks.CONDUIT)) {
+            return BlockLogicConduit.getOpenSides(state.get()).length > 0;
+        }
+        return false;
     }
 
     /**
@@ -380,7 +395,7 @@ public class WireHandler {
         BlockState state = WorldHelper.getBlockState(this.world, pos);
 
         boolean wasWire = node.isWire();
-        boolean isWire = state.is(Blocks.WIRE_REDSTONE);
+        boolean isWire = isPowerNodeState(state);
 
         if (wasWire != isWire) {
             return getNextNode(pos, state);
@@ -680,7 +695,7 @@ public class WireHandler {
         wire.discovered = true;
         wire.searched = false;
 
-        if (!wire.removed && !wire.shouldBreak && !wire.state.canSurvive(this.world, wire.pos)) {
+        if (!wire.is(CONDUIT) && !wire.removed && !wire.shouldBreak && !wire.state.canSurvive(this.world, wire.pos)) {
             wire.shouldBreak = true;
         }
 
@@ -732,7 +747,7 @@ public class WireHandler {
                 int power = Math.max(POWER_MIN, neighbor.virtualPower - POWER_STEP);
                 int iOpp = Directions.iOpposite(connection.iDir);
 
-                wire.offerPower(power, iOpp);
+                wire.offerPower(power, iOpp, connection.flow);
             }
         });
     }
@@ -741,11 +756,16 @@ public class WireHandler {
      * Determine the redstone signal the given wire receives from non-wire
      * components and update the virtual power accordingly.
      */
-    private void findExternalPower(WireNode wire) {
+    private void findExternalPower(@NotNull WireNode wire) {
         if (wire.removed || wire.shouldBreak || wire.externalPower >= POWER_MAX) {
             return;
         }
 
+        if (wire.is(CONDUIT)) {
+            findExternalPowerConduit(wire);
+            return;
+        }
+
         int maxExternalPower = POWER_MIN;
 
         for (int iDir = 0; iDir < Directions.ALL.length; iDir++) {
@@ -755,32 +775,6 @@ public class WireHandler {
                 continue;
             }
 
-            //conduit logic
-            if (neighboringNode.state.is(Blocks.CONDUIT)) {
-                int cData = neighboringNode.state.get();
-
-                Side conduitFace = getSide(iDir);
-
-                if (BlockLogicConduit.isSideOpen(cData, conduitFace)) {
-                    int cStrength = cData / BlockLogicConduit.STATE_COUNT;
-                    int convertedStrength = BlockLogicConduit.signalConverter(cStrength, true);
-
-                    //step down the signal strength when passing from conduit to wire
-                    convertedStrength = Math.max(0, convertedStrength - 1);
-
-                    //if signal is less than current power, set to 0
-                    if (convertedStrength < wire.currentPower) {
-                        convertedStrength = 0;
-                    }
-
-                    if (convertedStrength > maxExternalPower) {
-                        maxExternalPower = convertedStrength;
-                    }
-                }
-                //this continue took me hours to find. I hate my life
-                continue;
-            }
-
             if (neighboringNode.isConductor() && hasDirectSignalTo(wire, neighboringNode, Directions.iOpposite(iDir))) {
                 maxExternalPower = POWER_MAX;
             }
@@ -796,19 +790,34 @@ public class WireHandler {
         }
     }
 
-    private static @NotNull Side getSide(int iDir) {
-        Side wireSide = Side.NONE;
-        wireSide = switch (iDir) {
-            case Directions.WEST -> Side.WEST;
-            case Directions.NORTH -> Side.NORTH;
-            case Directions.EAST -> Side.EAST;
-            case Directions.SOUTH -> Side.SOUTH;
-            case Directions.DOWN -> Side.BOTTOM;
-            case Directions.UP -> Side.TOP;
-            default -> wireSide;
-        };
+    /**
+     * Determine the redstone signal a conduit node receives from non-network
+     * components through its open faces. Adjacent dust and conduits are skipped
+     * here because they are network nodes and reach this conduit via connections.
+     */
+    private void findExternalPowerConduit(@NotNull WireNode conduit) {
+        int maxExternalPower = POWER_MIN;
+
+        int data = conduit.state.get();
+        for (Side side : BlockLogicConduit.getOpenSides(data)) {
+            TilePos nPos = new TilePos(conduit.pos).add(side);
+            Block<?> nType = this.world.getBlockType(nPos);
+
+            if (nType == Blocks.WIRE_REDSTONE || nType == Blocks.CONDUIT) {
+                continue;
+            }
+
+            int external = BlockLogicConduit.getAndConvertNeighborSignal(this.world, conduit.pos, side);
+            if (external > maxExternalPower) {
+                maxExternalPower = external;
+            }
+        }
 
-        return wireSide.opposite();
+        conduit.externalPower = conduit.clampPower(maxExternalPower);
+
+        if (conduit.externalPower > conduit.virtualPower) {
+            conduit.virtualPower = conduit.externalPower;
+        }
     }
 
     /**
@@ -841,8 +850,19 @@ public class WireHandler {
      * Determine whether the given wire receives a direct signal from non-wire
      * components through the given conductor node.
      */
-    private boolean hasDirectSignalTo(WireNode wire, Node node, int except) {
+    private boolean hasDirectSignalTo(WireNode wire, @NotNull Node node, int except) {
+        if (node.state.is(Blocks.BLOCK_REDSTONE) || node.state.is(Blocks.MATCHER) || node.state.is(Blocks.MATCHER_ACTIVE)) {
+            return false;
+        }
+        Direction excludedFace = node.state.is(Blocks.PUMPKIN_REDSTONE)
+            ? BlockLogicVeryRotatable.metaToDirection(node.state.get())
+            : null;
+
         for (int iDir : Directions.I_EXCEPT[except]) {
+            if (Directions.ALL[iDir] == excludedFace) {
+                continue;
+            }
+
             Node neighbor = getNeighbor(node, iDir);
 
             if (neighbor.state.is(Blocks.WIRE_REDSTONE) || neighbor.state.is(Blocks.CONDUIT)) {
@@ -860,14 +880,14 @@ public class WireHandler {
     /**
      * Check if the given wire needs to update its state in the world.
      */
-    private boolean needsUpdate(WireNode wire) {
+    private boolean needsUpdate(@NotNull WireNode wire) {
         return wire.removed || wire.shouldBreak || wire.virtualPower != wire.currentPower;
     }
 
     /**
      * Queue the given wire for the breadth-first search as a root.
      */
-    private void searchRoot(WireNode wire) {
+    private void searchRoot(@NotNull WireNode wire) {
         int iBackupFlowDir;
 
         if (wire.connections.iFlowDir < 0) {
@@ -985,15 +1005,18 @@ public class WireHandler {
                 discover(neighbor);
                 findPower(neighbor, false);
 
-                // If power from neighboring wires has decreased, check for power
-                // from non-wire components so as to determine how low power can
-                // fall.
+                /*  If power from neighboring wires has decreased, check for power
+                    from non-wire components to determine how low power can
+                    fall. */
                 if (neighbor.virtualPower < neighbor.currentPower) {
                     findExternalPower(neighbor);
                 }
 
                 if (needsUpdate(neighbor)) {
-                    search(neighbor, false, connection.iDir);
+                    /*  The backup flow direction must be a horizontal direction.
+                        Conduit/vertical connections are non-flow and may carry a vertical
+                        iDir, so they fall back to a default rather than corrupting the flow.  */
+                    search(neighbor, false, connection.flow ? connection.iDir : Directions.WEST);
                 }
             }, wire.iFlowDir);
         }
@@ -1057,6 +1080,10 @@ public class WireHandler {
 
                 if (neighborWire != null) {
                     updateBlock(node, neighborWire.state.getBlockType());
+
+                    if (neighborWire.is(CONDUIT)) {
+                        this.world.notifyBlocksOfNeighborChange(node.pos, Blocks.CONDUIT);
+                    }
                 }
             }
         }
@@ -1096,7 +1123,7 @@ public class WireHandler {
             int power = Math.max(POWER_MIN, wire.virtualPower - POWER_STEP);
             int iDir = connection.iDir;
 
-            if (neighbor.offerPower(power, iDir)) {
+            if (neighbor.offerPower(power, iDir, connection.flow)) {
                 queueWire(neighbor);
             }
         }, wire.iFlowDir);
@@ -1105,16 +1132,56 @@ public class WireHandler {
     /**
      * Queue block updates to nodes around the given wire.
      */
-    private void queueNeighbors(WireNode wire) {
-        forEachNeighbor(wire, neighbor -> {
-            queueNeighbor(neighbor, wire);
-        });
+    private void queueNeighbors(@NotNull WireNode wire) {
+        if (wire.is(CONDUIT)) {
+            queueConduitNeighbors(wire);
+        } else {
+            forEachNeighbor(wire, neighbor -> {
+                queueNeighbor(neighbor, wire);
+            });
+        }
+    }
+
+    /**
+     * Queue block updates for the real components a conduit touches: the blocks on
+     * its open faces, plus matchers on any side.
+     * Network nodes are skipped, since power reaches them via connections.
+     */
+    private void queueConduitNeighbors(@NotNull WireNode conduit) {
+        int data = conduit.state.get();
+
+        for (int iDir = 0; iDir < Directions.ALL.length; iDir++) {
+            Node neighbor = getNeighbor(conduit, iDir);
+
+            if (neighbor.isWire()) {
+                continue;
+            }
+
+            boolean isOpen = BlockLogicConduit.isSideOpen(data, iDirToSide(iDir));
+            boolean isMatcher = neighbor.state.getBlockType().getLogic() instanceof BlockLogicMatcher;
+
+            if (isOpen || isMatcher) {
+                queueNeighbor(neighbor, conduit);
+            }
+        }
+    }
+
+    private static @NotNull Side iDirToSide(int iDir) {
+        return switch (iDir) {
+            case Directions.WEST -> Side.WEST;
+            case Directions.NORTH -> Side.NORTH;
+            case Directions.EAST -> Side.EAST;
+            case Directions.SOUTH -> Side.SOUTH;
+            case Directions.DOWN -> Side.BOTTOM;
+            case Directions.UP -> Side.TOP;
+            default -> Side.NONE;
+        };
     }
 
     /**
      * Queue the given node for an update from the given neighboring wire.
      */
-    private void queueNeighbor(Node node, WireNode neighborWire) {
+    private void queueNeighbor(@NotNull Node node, WireNode neighborWire) {
         // Updates to wires are queued when power is transmitted.
         if (!node.isWire()) {
             node.neighborWire = neighborWire;
@@ -1139,7 +1206,7 @@ public class WireHandler {
     /**
      * Emit a block update to the given node.
      */
-    private void updateBlock(Node node, Block<?> neighborBlock) {
+    private void updateBlock(@NotNull Node node, Block<?> neighborBlock) {
         TilePos pos = node.pos;
         BlockState state = WorldHelper.getBlockState(this.world, pos);
 
